function [radici,iter]=newtonhorner(a,x0,tol,nmax)
%NEWTONHORNER
if nargin == 2
    tol = 1.e-04;
    nmax = 100;
elseif nargin == 3
    nmax = 100;
end
n=length(a)-1;
radici = zeros(n,1);
iter = zeros(n,1);

for k = 1:n
    % Iterazioni di Newton
    niter = 0;
    x = x0;
    diff = tol + 1;
    while niter < nmax & diff >= tol
        [pz,b] = horner(a,x);
        [dpz,b] = horner(b,x);
        xnew = x - pz/dpz;
        diff = abs(xnew-x);
        niter = niter + 1;
        x = xnew;
    end

    if (niter==nmax & diff> tol)
      fprintf([' den siglinei',...
              ' se auto to plithos epanalipseon\n ']);
    end
    % Deflazione
    [pz,a] = horner(a,x);
    radici(k) = x;
    iter(k) = niter;
end
return
