function [c,yc,err,P] = regula(f,a,b,delta,epsilon,max1)
% Inputs
% f name of the function
% a left endpoint of the initial interval
% b right endpoint of the initial interval
% delta convergence tolerance for c
% epsilon convergence tolerance for yc
% max1 maximum number of iterations
% Return
% c solution: the root
% yc solution: the function value
% err error estimate in the solution c
% P History vector of the iterations
P = [a b];
ya = feval(f,a);
yb = feval(f,b);
if ya*yb > 0,return,end
for k=1:max1,
dx = yb*(b - a)/(yb - ya);
c = b - dx;
ac = c - a;
yc = feval(f,c);
if yc == 0,
break;
elseif yb*yc > 0,
b = c;
yb = yc;
else
a = c;
ya = yc;
end
P = [P;a b];
dx = min(abs(dx),ac);
if abs(dx) < delta, break, end
if abs(yc) < epsilon, break, end
end
err = abs(dx);



